using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.SalesReturn.Cqrs;

public record DeleteSalesReturnItemCommand(string Id) : IRequest<bool>;

public class DeleteSalesReturnItemHandler : IRequestHandler<DeleteSalesReturnItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteSalesReturnItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteSalesReturnItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}